﻿using System;
using System.Configuration;
using System.IO;
using Kreta.Core.Elearning.Nexius;

namespace Kreta.Web.Configuration
{
    public class NexiusCourseServiceConfiguration : ConfigurationSection, INexiusCourseServiceConfiguration
    {
        [ConfigurationProperty(nameof(ApplicationId))]
        public string ApplicationId => (string)base[nameof(ApplicationId)];

        [ConfigurationProperty(nameof(ApplicationSecret))]
        public string ApplicationSecret => (string)base[nameof(ApplicationSecret)];

        [ConfigurationProperty(nameof(ApplicationTokenGeneratorUrl))]
        public string ApplicationTokenGeneratorUrl => (string)base[nameof(ApplicationTokenGeneratorUrl)];

        [ConfigurationProperty("RequestBaseUrl")]
        public Uri RequestBaseUri => (Uri)base["RequestBaseUrl"];

        [ConfigurationProperty(nameof(CourseAccessXmlPath))]
        public string CourseAccessXmlPath => Path.Combine(AppDomain.CurrentDomain.BaseDirectory, (string)base[nameof(CourseAccessXmlPath)]);

        [ConfigurationProperty(nameof(TokenRetryCount))]
        public int TokenRetryCount => (int)base[nameof(TokenRetryCount)];
    }
}
